#!/usr/bin/env node  
require('events').EventEmitter.prototype._maxListeners = 0;
const {program} = require('commander')
const spawn = require('cross-spawn')
const path = require('path')
const package = require('../package.json')
let script = '';

program
    .version(package.version)
program
    .command('init')
    .argument('[projectName]', 'mmmm')
    .alias('i')
    .option('-c, --cover', '如果工程名称存在就覆盖掉')
    .description('初始化项目')
    .action(function (projectName) {
      script = 'init';
    }),
program
    .command('dev')
    .alias('d')
    .description('开发')
    .action(function (name) {
        script = 'dev';
    })
program
    .command('build')
    .alias('b')
    .option('-r, --remove', 'build之前将dist目录删掉')
    .description('发布上线')
    .action(function (name) {
        script = 'build';
    })
program
    .command('start', '')
    .alias('s')
    .description('开发自动启动服务')
    .action(function (name) {
        script = 'start';
    })
program
    .parse(process.argv)

let args = process.argv.slice(3);

if (script === 'build') {
  const buildOptions = ['-a', '--all', '--remove', '-r']
  let i, pageName
  for (i = 0; i !== args.length; i++) {
    if (buildOptions.indexOf(args[i]) === -1) {
      pageName = args[i]
      break
    }
  }
  if (!pageName) {
    // 没传pageName
    args.unshift('')
  } else if (i !== 0) {
    // 如果传入了pageName，但不是第一个参数
    args.splice(i, 1)
    args.unshift(pageName)
  }
}

switch (script) {
    case 'init':
    case 'dev':
    case 'build':
    case 'start':
        const result = spawn.sync(
            'node',
            ['--max_old_space_size=8192'].concat([require.resolve(path.join('../scripts', script))],args),
            { stdio: 'inherit' }
        );
        // console.log(result)
        process.exit(result.status);
        break;
    default:
        // console.log(script)
        console.log('Run syue --help to see all options.')
        break;
}